<?php
require_once dirname(__FILE__).'/Template.php';

final class Document extends Template {
	public $childNodes;

	function __construct($templates) {
		$this->childNodes = array();
		foreach($templates as $node) {
			if(end($this->childNodes) and !($node instanceof Template))
				$this->childNodes[count($this->childNodes) - 1] .= (string) $node;
			else {
				$this->childNodes[]	= $node instanceof Template
									? $node
									: (string) $node;
			}
		}
	}

	function toSourceCode() {
		$code = '';
		foreach($this->childNodes as $node) {
			$code	.= $node instanceof Template
					 ? $node->toSourceCode()
					 : self::toPHPEcho($node);
		}

		return $code;
	}
}

?>
